#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>

#define NOT_FOUND -1

char dict[200000][20];

int binSearch(char[],int,int);
int readFile(char[]);
void getWord(int,int,char[],char[]);
void permute(int,int,char[]);
void swap(int,int,char[]);
void copyArray(int,char[]);
void process(int,char[]);

void main(int argc, char** argv)                
{
 char word[20+1];
 strcpy(word,argv[1]);
 int len = strlen(word);
 cout<<"word: "<<word<<" -> length: "<<len<<endl;
 for(int i=len; i>0; i--)
 {
   permute(i,11,word);
   cout<<endl;
 }
}

void getWord(int index, int max, char word1[], char word2[])
{
 int i,j=0;
 for(i=index; i<max; i++)
   word2[j++] = word1[i];
 word2[j]='\0';
}

void permute(int m, int max, char A[]) 
{ 
 if(m==0) 
   process(max,A); 
 else
 {
  permute(m-1,max,A);
  for(int i=m-1; i>=0; i--)
  {
   swap(m,i,A);
   permute(m-1,max,A);
   swap(m,i,A);
  }
 }
}

void process(int max,char A[])
{
 int len = strlen(A);
 char B[20+1]; B[0] ='\0';
 char C[20+1]; C[0] ='\0';
 int found1, found2;
 for(int i=len; i>0; i--)
 {
  found1 = 0; found2 = 0;
  getWord(0,i,A,B);
  getWord(i,len,A,C);
  cout<<A<<" > "<<B<<" & "<<C<<endl;
/**  if((strlen(B)>2)&&(strlen(C)>2))
  {
    found1 = binSearch(B,0,max);
    found2 = binSearch(C,0,max);
    if((found1!=NOT_FOUND)||(found2!=NOT_FOUND))
      cout<<A<<" > "<<B<<" "<<C<<endl;
  }
  else if((strlen(B)==0)||(strlen(C)==0))
  {
   if(strlen(B) != 0)
     found1 = binSearch(B,0,max);
   if(strlen(C) != 0)
     found2 = binSearch(C,0,max);
   if((found1!=NOT_FOUND)||(found2!=NOT_FOUND))
     cout<<A<<" > "<<B<<" "<<C<<endl;
  }
*/
 }
}

void swap(int m,int i,char word[])
{
 if(strlen(word) < 2)
   return; 
 char tmp = word[m];
 word[m] = word[i];
 word[i] = tmp;
}

int readFile(char x[])
{
 ifstream f (x);
 if(!f.is_open())
 {
  cout<<"Error in opening: "<<f<<endl;
  return 0;
 }
 char tmp[20+1];
 int count = 0;
 while(!f.eof())
 {
  f.getline(tmp,20);
  strcpy(dict[count],tmp);
  count++;
 }
 f.close();
 return count-1;
}

int binSearch(char x[], int left, int right)
{
 if(left == right)
   return NOT_FOUND;
 else
 {
  int m = (left+right)/2;
  char tmp[20+1];
  copyArray(m,tmp);
  if(strcmp(x,tmp)<0)
    return binSearch(x,left,m);
  else if(strcmp(x,tmp)>0)
    return binSearch(x,m+1,right);
  else
    return m;
 }
}

void copyArray(int index, char dest[])
{
 int i;
 for(i=0;i<20;i++)
   if(dict[index][i] != '\0')
     dest[i] = dict[index][i];
   else
     break;
 dest[i]='\0';
}
